;This is a program that draws a tji floor joist or steel beam with faces.
;Written by Darren Besel 
;From MSU-B-COT programing for CAD Applications class.
;
;
(DEFUN C:FLRJOIST ()
 (SETVAR "CMDECHO" 0)
 (setq lth (GETDIST "\nLength of floor joist:"))
 (setq djf (getdist "\nDepth of joist flange:"))
 (setq jwt (getdist "\njoist web thickness:"))
 (setq jwd (getdist "\njoist web depth:"))
 (setq tjf (getdist "\nThickness of joist flange:"))
 (setq fj (getpoint "\nSelect bottom center of floor joist:"))
  (setq cl (getvar "clayer"))
 ;End of info gathering sequence-Start of polar point setting
 (setq fj2 (polar fj (dtr 0.0) lth))
 (setq fj3 (polar fj2 (dtr 270) (* tjf 0.5)))
 (setq fj6 (polar fj2 (dtr 90) (* tjf 0.5)))
 (setq fj5 (list (car fj6) (cadr fj6) (+(caddr fj6)djf)))
 (setq fj4 (list (car fj3) (cadr fj3) (+(caddr fj3)djf)))
 (setq fj10 (polar fj (dtr 270) (* tjf 0.5)))
 (setq fj7 (polar fj (dtr 90) (* tjf 0.5)))
 (setq fj8 (list (car fj7) (cadr fj7) (+(caddr fj7)djf))) 
 (setq fj9 (list (car fj10) (cadr fj10) (+(caddr fj10)djf)))
 (setq jd (list (car fj) (cadr fj) (+(caddr fj)jwd djf)))
 (setq jd2 (list (car fj2) (cadr fj2) (+(caddr fj2)jwd djf)))
 (setq wd10 (list (car fj) (cadr fj) (+(caddr fj)tjf)))
 (setq wd11 (list (car fj2) (cadr fj2) (+(caddr fj2)tjf)))
 (setq wd12 (list (car jd2) (cadr jd2) (+(caddr jd2)tjf)))
 (setq wd9 (list (car wd10) (cadr wd10) (+(caddr wd10)jwd)))
 (setq wd8 (polar wd11 (dtr 270) (* jwt 0.5)))
 (setq wd5 (polar wd11 (dtr 90) (* jwt 0.5)))
 (setq wd7 (list (car wd8) (cadr wd8) (+(caddr wd8)jwd)))
 (setq wd6 (list (car wd5) (cadr wd5) (+(caddr wd5)jwd)))
 (setq wd3 (polar wd10 (dtr 270)(* jwt 0.5)))
 (setq wd4 (polar wd10 (dtr 90) (* jwt 0.5)))
 (setq wd2 (list (car wd3) (cadr wd3) (+(caddr wd3)jwd)))
 (setq wd1 (list (car wd4) (cadr wd4) (+(caddr wd4)jwd)))
 (setq tj2 (polar jd (dtr 270) (* tjf 0.5)))
 (setq tj5 (polar jd (dtr 90) (* tjf 0.5)))
 (setq tj3 (list (car tj2) (cadr tj2) (+(caddr tj2)djf)))
 (setq tj4 (list (car tj5) (cadr tj5) (+(caddr tj5)djf)))
 (setq tj9 (polar jd2 (dtr 270) (* tjf 0.5)))
 (setq tj6 (polar jd2 (dtr 90) (* tjf 0.5)))
 (setq tj8 (list (car tj9) (cadr tj9) (+(caddr tj9)djf)))
 (setq tj7 (list (car tj6) (cadr tj6) (+(caddr tj6)djf)))
;End of the polar point setting-Start of drawing sequence
 (command "layer" "m" "tji" "c" "yellow" "" "")
  (command "line" fj7 fj8 fj9 fj10 "c")
  (command "line" wd4 wd1 wd2 wd3 "c")
  (command "line" tj2 tj3 tj4 tj5 "c")
  (command "line" fj3 fj4 fj5 fj6 "c")
  (command "line" wd8 wd7 wd6 wd5 "c")
  (command "line" tj8 tj9 tj6 tj7 "c")
  (command "line" tj5 tj6 "")
  (command "line" tj2 tj9 "")
  (command "line" tj3 tj8 "")
  (command "line" tj4 tj7 "")
  (command "line" fj7 fj6 "")
  (command "line" fj8 fj5 "")
  (command "line" fj9 fj4 "")
  (command "line" fj10 fj3 "")
  (command "line" wd1 wd6 "")
  (command "line" wd2 wd7 "")
  (command "line" wd3 wd8 "")
  (command "line" wd4 wd5 "")

(command "3DFACE" fj7 fj8 fj9 fj10 "")
  (command "3DFACE" wd4 wd1 wd2 wd3 "")
  (command "3DFACE" tj2 tj3 tj4 tj5 "")
  (command "3DFACE" fj3 fj4 fj5 fj6 "")
  (command "3DFACE" wd8 wd7 wd6 wd5 "")
  (command "3DFACE" tj8 tj9 tj6 tj7 "")
  (command "3DFACE" tj5 tj6 tj7 tj4 "")
  (command "3DFACE" tj2 tj9 tj8 tj3 "")
  (command "3DFACE" fj7 fj6 fj5 fj8 "")
  (command "3DFACE" fj9 fj4 fj3 fj10 "")
  (command "3DFACE" wd1 wd6 wd5 wd4 "")
  (command "3DFACE" wd2 wd7 wd8 wd3 "")
  (command "3DFACE" tj2 tj5 tj6 tj9 "")
  (command "3DFACE" tj3 tj4 tj7 tj8 "")
  (command "3DFACE" fj8 fj9 fj4 fj5 "")
  (command "3DFACE" fj6 fj7 fj10 fj3 "")
(setvar "clayer" cl)
)
(defun dtr (a) (* pi (/ a 180.0)))
(princ "\nCreates a 3d floor joist or beam")
(princ)